# Class NodeWrapper<TWrappedModule>

#### Type Parameters

- #### TWrappedModule extends NodeModule = NodeModule

#### Hierarchy

- ModuleWrapper<TWrappedModule>
  - NodeWrapper

- Defined in modules/packages/node/packages/wrapper/dist/types/NodeWrapper.d.ts:3

#####
Index

### Constructors

constructor

### Properties

eventData
params
wrapperParams
defaultLogger?
requiredQueries

### Accessors

account
address
config
downResolver
logger
module
queries
upResolver

### Methods

attach
attached
bindQuery
bindQueryInternal
clearListeners
describe
detach
discover
emit
emitSerial
filterErrors
listenerCount
off
offAny
on
onAny
once
previousHash
query
queryable
registered
resolve
resolveWrapped
sendQuery
throwErrors
canWrap
hasRequiredQueries
isNodeModule
missingRequiredQueries
tryWrap
wrap

## Constructors

### constructor

- new NodeWrapper<TWrappedModule>(params): NodeWrapper<TWrappedModule>

- #### Type Parameters

  - #### TWrappedModule extends Node & ModuleFields<NodeModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.node.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    archivist?: string;
    schema: "network.xyo.node.config";
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<NodeModuleEventData, TWrappedModule> = NodeModule<NodeModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.node.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    archivist?: string;
    schema: "network.xyo.node.config";
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, NodeModuleEventData>

  #### Parameters

  - ##### params: BaseParamsFields & {
    account?: AccountInstance;
    module: TWrappedModule;
    }

  #### Returns NodeWrapper<TWrappedModule>

  Inherited from ModuleWrapper.constructor

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:29

## Properties

### eventData

eventData: TWrappedModule["eventData"]

Inherited from ModuleWrapper.eventData

- Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:27

### `Readonly` params

params: TWrappedModule["params"]

Inherited from ModuleWrapper.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Protected` `Readonly` wrapperParams

wrapperParams: BaseParamsFields & {
account?: AccountInstance;
module: TWrappedModule;
}

Inherited from ModuleWrapper.wrapperParams

- Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:28

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from ModuleWrapper.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

### `Static` requiredQueries

requiredQueries: string[]

Overrides ModuleWrapper.requiredQueries

- Defined in modules/packages/node/packages/wrapper/dist/types/NodeWrapper.d.ts:4

## Accessors

### account

- get account(): undefined | AccountInstance

- #### Returns undefined | AccountInstance

  Inherited from ModuleWrapper.account

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:30

### address

- get address(): string

- #### Returns string

  Inherited from ModuleWrapper.address

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:31

### config

- get config(): TWrappedModule["config"]

- #### Returns TWrappedModule["config"]

  Inherited from ModuleWrapper.config

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:32

### downResolver

- get downResolver(): ModuleResolver

- #### Returns ModuleResolver

  Inherited from ModuleWrapper.downResolver

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:33

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from ModuleWrapper.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### module

- get module(): TWrappedModule

- #### Returns TWrappedModule

  Inherited from ModuleWrapper.module

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:34

### queries

- get queries(): string[]

- #### Returns string[]

  Inherited from ModuleWrapper.queries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:35

### upResolver

- get upResolver(): ModuleResolver

- #### Returns ModuleResolver

  Inherited from ModuleWrapper.upResolver

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:36

## Methods

### attach

- attach(nameOrAddress, external?): Promise<undefined | string>

- #### Parameters

  - ##### nameOrAddress: string

  - ##### `Optional` external: boolean

  #### Returns Promise<undefined | string>

  - Defined in modules/packages/node/packages/wrapper/dist/types/NodeWrapper.d.ts:6

### attached

- attached(): Promise<string[]>

- #### Returns Promise<string[]>

  - Defined in modules/packages/node/packages/wrapper/dist/types/NodeWrapper.d.ts:7

### `Protected` bindQuery

- bindQuery<T>(query, payloads?, account?): PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

  Inherited from ModuleWrapper.bindQuery

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:71

### `Protected` bindQueryInternal

- bindQueryInternal<T>(query, payloads?, account?): Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from ModuleWrapper.bindQueryInternal

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:72

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: Parameters<TWrappedModule["clearListeners"]>[0]

  #### Returns void

  Inherited from ModuleWrapper.clearListeners

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:42

### describe

- describe(): Promise<Promise<Promisable<ModuleDescription, never>>>

- #### Returns Promise<Promise<Promisable<ModuleDescription, never>>>

  Inherited from ModuleWrapper.describe

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:43

### detach

- detach(nameOrAddress): Promise<undefined | string>

- #### Parameters

  - ##### nameOrAddress: string

  #### Returns Promise<undefined | string>

  - Defined in modules/packages/node/packages/wrapper/dist/types/NodeWrapper.d.ts:8

### discover

- discover(): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from ModuleWrapper.discover

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:44

### emit

- emit(eventName, eventArgs): Promise<void>

- #### Parameters

  - ##### eventName: Parameters<TWrappedModule["emit"]>[0]

  - ##### eventArgs: Parameters<TWrappedModule["emit"]>[1]

  #### Returns Promise<void>

  Inherited from ModuleWrapper.emit

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:45

### emitSerial

- emitSerial(eventName, eventArgs): Promise<void>

- #### Parameters

  - ##### eventName: Parameters<TWrappedModule["emitSerial"]>[0]

  - ##### eventArgs: Parameters<TWrappedModule["emitSerial"]>[1]

  #### Returns Promise<void>

  Inherited from ModuleWrapper.emitSerial

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:46

### `Protected` filterErrors

- filterErrors(query, result): (null | SchemaFields & PayloadFields & {
  message?: string;
  schema: "network.xyo.error.module";
  sources?: string[];
  })[]

- #### Parameters

  - ##### query: [SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }, (SchemaFields & PayloadFields & {
    schema: string;
    })[]]

  - ##### result: undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
    schema: string;
    }>

  #### Returns (null | SchemaFields & PayloadFields & {
  message?: string;
  schema: "network.xyo.error.module";
  sources?: string[];
  })[]

  Inherited from ModuleWrapper.filterErrors

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:73

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: Parameters<TWrappedModule["listenerCount"]>[0]

  #### Returns number

  Inherited from ModuleWrapper.listenerCount

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:47

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName

  - ##### listener: EventListener<TWrappedModule["eventData"][TEventName]>

  #### Returns void

  Inherited from ModuleWrapper.off

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:48

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Inherited from ModuleWrapper.offAny

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:49

### on

- on<TEventName>(eventNames, listener): EventUnsubscribeFunction

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName

  - ##### listener: EventListener<TWrappedModule["eventData"][TEventName]>

  #### Returns EventUnsubscribeFunction

  Inherited from ModuleWrapper.on

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:50

### onAny

- onAny(listener): EventUnsubscribeFunction

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns EventUnsubscribeFunction

  Inherited from ModuleWrapper.onAny

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:51

### once

- once<TEventName>(eventName, listener): EventUnsubscribeFunction

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<TWrappedModule["eventData"][TEventName]>

  #### Returns EventUnsubscribeFunction

  Inherited from ModuleWrapper.once

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:52

### previousHash

- previousHash(): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from ModuleWrapper.previousHash

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:53

### query

- query<T>(query, payloads?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Inherited from ModuleWrapper.query

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:54

### queryable

- queryable<T>(query, payloads?): Promisable<boolean, never>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promisable<boolean, never>

  Inherited from ModuleWrapper.queryable

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:55

### registered

- registered(): Promise<string[]>

- #### Returns Promise<string[]>

  - Defined in modules/packages/node/packages/wrapper/dist/types/NodeWrapper.d.ts:9

### resolve

- resolve<TModule>(filter?): Promise<TModule[]>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Inherited from ModuleWrapper.resolve

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:56
- resolve<TModule>(nameOrAddress): Promise<undefined | TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### nameOrAddress: string

  #### Returns Promise<undefined | TModule>

  Inherited from ModuleWrapper.resolve

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:57

### resolveWrapped

- resolveWrapped<T>(wrapper, filter?): Promise<T[]>

- Resolves the supplied filter into wrapped modules

  ### Example

  Example using ArchivistWrapper

      const filter = { address: [address] }
      const mods: ArchivistWrapper[] = await node.resolveWrapped(ArchivistWrapper, filter)

  #### Type Parameters

  - #### T extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, T> = ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>>

  #### Parameters

  - ##### wrapper: ConstructableModuleWrapper<T>

    The ModuleWrapper class (ArchivistWrapper, DivinerWrapper, etc.)

  - ##### `Optional` filter: ModuleFilter

    The ModuleFilter

  #### Returns Promise<T[]>

  An array of ModuleWrapper instances corresponding to the underlying modules matching the supplied filter

  Inherited from ModuleWrapper.resolveWrapped

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:69
- resolveWrapped<T>(wrapper, nameOrAddress): Promise<undefined | T>

- #### Type Parameters

  - #### T extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, T> = ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>>

  #### Parameters

  - ##### wrapper: ConstructableModuleWrapper<T>

  - ##### nameOrAddress: string

  #### Returns Promise<undefined | T>

  Inherited from ModuleWrapper.resolveWrapped

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:70

### `Protected` sendQuery

- sendQuery<T>(queryPayload, payloads?): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### queryPayload: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from ModuleWrapper.sendQuery

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:74

### `Protected` throwErrors

- throwErrors(query, result): void

- #### Parameters

  - ##### query: [SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }, (SchemaFields & PayloadFields & {
    schema: string;
    })[]]

  - ##### result: undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
    schema: string;
    }>

  #### Returns void

  Inherited from ModuleWrapper.throwErrors

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:75

### `Static` canWrap

- canWrap(module?): boolean

- #### Parameters

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns boolean

  Inherited from ModuleWrapper.canWrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:37

### `Static` hasRequiredQueries

- hasRequiredQueries(module): boolean

- #### Parameters

  - ##### module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns boolean

  Inherited from ModuleWrapper.hasRequiredQueries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:38

### `Static` isNodeModule

- isNodeModule(module): boolean

- #### Parameters

  - ##### module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns boolean

  - Defined in modules/packages/node/packages/wrapper/dist/types/NodeWrapper.d.ts:5

### `Static` missingRequiredQueries

- missingRequiredQueries(module): string[]

- #### Parameters

  - ##### module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns string[]

  Inherited from ModuleWrapper.missingRequiredQueries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:39

### `Static` tryWrap

- tryWrap<TModuleWrapper>(this, module?, account?): undefined | TModuleWrapper

- #### Type Parameters

  - #### TModuleWrapper extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, TModuleWrapper>

  #### Parameters

  - ##### this: ConstructableModuleWrapper<TModuleWrapper>

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  - ##### `Optional` account: AccountInstance

  #### Returns undefined | TModuleWrapper

  Inherited from ModuleWrapper.tryWrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:40

### `Static` wrap

- wrap<TModuleWrapper>(this, module?, account?): TModuleWrapper

- #### Type Parameters

  - #### TModuleWrapper extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, TModuleWrapper>

  #### Parameters

  - ##### this: ConstructableModuleWrapper<TModuleWrapper>

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  - ##### `Optional` account: AccountInstance

  #### Returns TModuleWrapper

  Inherited from ModuleWrapper.wrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:41

Generated using TypeDoc